<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="UTF-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Document</title>
</head>
<body>;
<p><em>Hooks</em> are a new addition in React 16.8. They let you use state and other React features without writing a class.</p>
<p>Building your own Hooks lets you extract component logic into reusable functions.</p>
<p>When we were learning about <a href="/docs/hooks-effect.html#example-using-hooks-1">using the Effect Hook</a>, we saw this component from a chat application that displays a message indicating whether a friend is online or offline:</p>
<pre class="js{4-15}"><code>import React, { useState, useEffect } from &#39;react&#39;;

function FriendStatus(props) {
  const [isOnline, setIsOnline] = useState(null);

  useEffect(() =&gt; {
    function handleStatusChange(status) {
      setIsOnline(status.isOnline);
    }

    ChatAPI.subscribeToFriendStatus(props.friend.id, handleStatusChange);
    return () =&gt; {
      ChatAPI.unsubscribeFromFriendStatus(props.friend.id, handleStatusChange);
    };
  });

  if (isOnline === null) {
    return &#39;Loading...&#39;;
  }
  return isOnline ? &#39;Online&#39; : &#39;Offline&#39;;
}</code></pre>
<p>Now let’s say that our chat application also has a contact list, and we want to render names of online users with a green color. We could copy and paste similar logic above into our <code>FriendListItem</code> component but it wouldn’t be ideal:</p>
<pre class="js{4-15}"><code>import React, { useState, useEffect } from &#39;react&#39;;

function FriendListItem(props) {
  const [isOnline, setIsOnline] = useState(null);

  useEffect(() =&gt; {
    function handleStatusChange(status) {
      setIsOnline(status.isOnline);
    }

    ChatAPI.subscribeToFriendStatus(props.friend.id, handleStatusChange);
    return () =&gt; {
      ChatAPI.unsubscribeFromFriendStatus(props.friend.id, handleStatusChange);
    };
  });

  return (
    &lt;li style={{ color: isOnline ? &#39;green&#39; : &#39;black&#39; }}&gt;
      {props.friend.name}
    &lt;/li&gt;
  );
}</code></pre>
<p>Instead, we’d like to share this logic between <code>FriendStatus</code> and <code>FriendListItem</code>.</p>
<p>Traditionally in React, we’ve had two popular ways to share stateful logic between components: <a href="/docs/render-props.html">render props</a> and <a href="/docs/higher-order-components.html">higher-order components</a>. We will now look at how Hooks solve many of the same problems without forcing you to add more components to the tree.</p>
<h2 id="extracting-a-custom-hook">Extracting a Custom Hook</h2>
<p>When we want to share logic between two JavaScript functions, we extract it to a third function. Both components and Hooks are functions, so this works for them too!</p>
<p><strong>A custom Hook is a JavaScript function whose name starts with “<code>use</code>” and that may call other Hooks.</strong> For example, <code>useFriendStatus</code> below is our first custom Hook:</p>
<pre class="js{3}"><code>import { useState, useEffect } from &#39;react&#39;;

function useFriendStatus(friendID) {
  const [isOnline, setIsOnline] = useState(null);

  useEffect(() =&gt; {
    function handleStatusChange(status) {
      setIsOnline(status.isOnline);
    }

    ChatAPI.subscribeToFriendStatus(friendID, handleStatusChange);
    return () =&gt; {
      ChatAPI.unsubscribeFromFriendStatus(friendID, handleStatusChange);
    };
  });

  return isOnline;
}</code></pre>
<p>There’s nothing new inside of it – the logic is copied from the components above. Just like in a component, make sure to only call other Hooks unconditionally at the top level of your custom Hook.</p>
<p>Unlike a React component, a custom Hook doesn’t need to have a specific signature. We can decide what it takes as arguments, and what, if anything, it should return. In other words, it’s just like a normal function. Its name should always start with <code>use</code> so that you can tell at a glance that the <a href="/docs/hooks-rules.html">rules of Hooks</a> apply to it.</p>
<p>The purpose of our <code>useFriendStatus</code> Hook is to subscribe us to a friend’s status. This is why it takes <code>friendID</code> as an argument, and returns whether this friend is online:</p>
<div class="sourceCode" id="cb4"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb4-1" title="1"><span class="kw">function</span> <span class="at">useFriendStatus</span>(friendID) <span class="op">{</span></a>
<a class="sourceLine" id="cb4-2" title="2">  <span class="kw">const</span> [isOnline<span class="op">,</span> setIsOnline] <span class="op">=</span> <span class="at">useState</span>(<span class="kw">null</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb4-3" title="3"></a>
<a class="sourceLine" id="cb4-4" title="4">  <span class="co">// ...</span></a>
<a class="sourceLine" id="cb4-5" title="5"></a>
<a class="sourceLine" id="cb4-6" title="6">  <span class="cf">return</span> isOnline<span class="op">;</span></a>
<a class="sourceLine" id="cb4-7" title="7"><span class="op">}</span></a></code></pre></div>
<p>Now let’s see how we can use our custom Hook.</p>
<h2 id="using-a-custom-hook">Using a Custom Hook</h2>
<p>In the beginning, our stated goal was to remove the duplicated logic from the <code>FriendStatus</code> and <code>FriendListItem</code> components. Both of them want to know whether a friend is online.</p>
<p>Now that we’ve extracted this logic to a <code>useFriendStatus</code> hook, we can <em>just use it:</em></p>
<pre class="js{2}"><code>function FriendStatus(props) {
  const isOnline = useFriendStatus(props.friend.id);

  if (isOnline === null) {
    return &#39;Loading...&#39;;
  }
  return isOnline ? &#39;Online&#39; : &#39;Offline&#39;;
}</code></pre>
<pre class="js{2}"><code>function FriendListItem(props) {
  const isOnline = useFriendStatus(props.friend.id);

  return (
    &lt;li style={{ color: isOnline ? &#39;green&#39; : &#39;black&#39; }}&gt;
      {props.friend.name}
    &lt;/li&gt;
  );
}</code></pre>
<p><strong>Is this code equivalent to the original examples?</strong> Yes, it works in exactly the same way. If you look closely, you’ll notice we didn’t make any changes to the behavior. All we did was to extract some common code between two functions into a separate function. <strong>Custom Hooks are a convention that naturally follows from the design of Hooks, rather than a React feature.</strong></p>
<p><strong>Do I have to name my custom Hooks starting with “<code>use</code>”?</strong> Please do. This convention is very important. Without it, we wouldn’t be able to automatically check for violations of <a href="/docs/hooks-rules.html">rules of Hooks</a> because we couldn’t tell if a certain function contains calls to Hooks inside of it.</p>
<p><strong>Do two components using the same Hook share state?</strong> No. Custom Hooks are a mechanism to reuse <em>stateful logic</em> (such as setting up a subscription and remembering the current value), but every time you use a custom Hook, all state and effects inside of it are fully isolated.</p>
<p><strong>How does a custom Hook get isolated state?</strong> Each <em>call</em> to a Hook gets isolated state. Because we call <code>useFriendStatus</code> directly, from React’s point of view our component just calls <code>useState</code> and <code>useEffect</code>. And as we <a href="/docs/hooks-state.html#tip-using-multiple-state-variables">learned</a> <a href="/docs/hooks-effect.html#tip-use-multiple-effects-to-separate-concerns">earlier</a>, we can call <code>useState</code> and <code>useEffect</code> many times in one component, and they will be completely independent.</p>
<h3 id="tip-pass-information-between-hooks">Tip: Pass Information Between Hooks</h3>
<p>Since Hooks are functions, we can pass information between them.</p>
<p>To illustrate this, we’ll use another component from our hypothetical chat example. This is a chat message recipient picker that displays whether the currently selected friend is online:</p>
<pre class="js{8-9,13}"><code>const friendList = [
  { id: 1, name: &#39;Phoebe&#39; },
  { id: 2, name: &#39;Rachel&#39; },
  { id: 3, name: &#39;Ross&#39; },
];

function ChatRecipientPicker() {
  const [recipientID, setRecipientID] = useState(1);
  const isRecipientOnline = useFriendStatus(recipientID);

  return (
    &lt;&gt;
      &lt;Circle color={isRecipientOnline ? &#39;green&#39; : &#39;red&#39;} /&gt;
      &lt;select
        value={recipientID}
        onChange={e =&gt; setRecipientID(Number(e.target.value))}
      &gt;
        {friendList.map(friend =&gt; (
          &lt;option key={friend.id} value={friend.id}&gt;
            {friend.name}
          &lt;/option&gt;
        ))}
      &lt;/select&gt;
    &lt;/&gt;
  );
}</code></pre>
<p>We keep the currently chosen friend ID in the <code>recipientID</code> state variable, and update it if the user chooses a different friend in the <code>&lt;select&gt;</code> picker.</p>
<p>Because the <code>useState</code> Hook call gives us the latest value of the <code>recipientID</code> state variable, we can pass it to our custom <code>useFriendStatus</code> Hook as an argument:</p>
<div class="sourceCode" id="cb8"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb8-1" title="1">  <span class="kw">const</span> [recipientID<span class="op">,</span> setRecipientID] <span class="op">=</span> <span class="at">useState</span>(<span class="dv">1</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb8-2" title="2">  <span class="kw">const</span> isRecipientOnline <span class="op">=</span> <span class="at">useFriendStatus</span>(recipientID)<span class="op">;</span></a></code></pre></div>
<p>This lets us know whether the <em>currently selected</em> friend is online. If we pick a different friend and update the <code>recipientID</code> state variable, our <code>useFriendStatus</code> Hook will unsubscribe from the previously selected friend, and subscribe to the status of the newly selected one.</p>
<h2 id="useyourimagination"><code>useYourImagination()</code></h2>
<p>Custom Hooks offer the flexibility of sharing logic that wasn’t possible in React components before. You can write custom Hooks that cover a wide range of use cases like form handling, animation, declarative subscriptions, timers, and probably many more we haven’t considered. What’s more, you can build Hooks that are just as easy to use as React’s built-in features.</p>
<p>Try to resist adding abstraction too early. Now that function components can do more, it’s likely that the average function component in your codebase will become longer. This is normal – don’t feel like you <em>have to</em> immediately split it into Hooks. But we also encourage you to start spotting cases where a custom Hook could hide complex logic behind a simple interface, or help untangle a messy component.</p>
<p>For example, maybe you have a complex component that contains a lot of local state that is managed in an ad-hoc way. <code>useState</code> doesn’t make centralizing the update logic any easier so you might prefer to write it as a <a href="https://redux.js.org/">Redux</a> reducer:</p>
<div class="sourceCode" id="cb9"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb9-1" title="1"><span class="kw">function</span> <span class="at">todosReducer</span>(state<span class="op">,</span> action) <span class="op">{</span></a>
<a class="sourceLine" id="cb9-2" title="2">  <span class="cf">switch</span> (<span class="va">action</span>.<span class="at">type</span>) <span class="op">{</span></a>
<a class="sourceLine" id="cb9-3" title="3">    <span class="cf">case</span> <span class="st">&#39;add&#39;</span><span class="op">:</span></a>
<a class="sourceLine" id="cb9-4" title="4">      <span class="cf">return</span> [...<span class="at">state</span><span class="op">,</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb9-5" title="5">        <span class="dt">text</span><span class="op">:</span> <span class="va">action</span>.<span class="at">text</span><span class="op">,</span></a>
<a class="sourceLine" id="cb9-6" title="6">        <span class="dt">completed</span><span class="op">:</span> <span class="kw">false</span></a>
<a class="sourceLine" id="cb9-7" title="7">      <span class="op">}</span>]<span class="op">;</span></a>
<a class="sourceLine" id="cb9-8" title="8">    <span class="co">// ... other actions ...</span></a>
<a class="sourceLine" id="cb9-9" title="9">    <span class="cf">default</span><span class="op">:</span></a>
<a class="sourceLine" id="cb9-10" title="10">      <span class="cf">return</span> state<span class="op">;</span></a>
<a class="sourceLine" id="cb9-11" title="11">  <span class="op">}</span></a>
<a class="sourceLine" id="cb9-12" title="12"><span class="op">}</span></a></code></pre></div>
<p>Reducers are very convenient to test in isolation, and scale to express complex update logic. You can further break them apart into smaller reducers if necessary. However, you might also enjoy the benefits of using React local state, or might not want to install another library.</p>
<p>So what if we could write a <code>useReducer</code> Hook that lets us manage the <em>local</em> state of our component with a reducer? A simplified version of it might look like this:</p>
<div class="sourceCode" id="cb10"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb10-1" title="1"><span class="kw">function</span> <span class="at">useReducer</span>(reducer<span class="op">,</span> initialState) <span class="op">{</span></a>
<a class="sourceLine" id="cb10-2" title="2">  <span class="kw">const</span> [state<span class="op">,</span> setState] <span class="op">=</span> <span class="at">useState</span>(initialState)<span class="op">;</span></a>
<a class="sourceLine" id="cb10-3" title="3"></a>
<a class="sourceLine" id="cb10-4" title="4">  <span class="kw">function</span> <span class="at">dispatch</span>(action) <span class="op">{</span></a>
<a class="sourceLine" id="cb10-5" title="5">    <span class="kw">const</span> nextState <span class="op">=</span> <span class="at">reducer</span>(state<span class="op">,</span> action)<span class="op">;</span></a>
<a class="sourceLine" id="cb10-6" title="6">    <span class="at">setState</span>(nextState)<span class="op">;</span></a>
<a class="sourceLine" id="cb10-7" title="7">  <span class="op">}</span></a>
<a class="sourceLine" id="cb10-8" title="8"></a>
<a class="sourceLine" id="cb10-9" title="9">  <span class="cf">return</span> [state<span class="op">,</span> dispatch]<span class="op">;</span></a>
<a class="sourceLine" id="cb10-10" title="10"><span class="op">}</span></a></code></pre></div>
<p>Now we could use it in our component, and let the reducer drive its state management:</p>
<pre class="js{2}"><code>function Todos() {
  const [todos, dispatch] = useReducer(todosReducer, []);

  function handleAddClick(text) {
    dispatch({ type: &#39;add&#39;, text });
  }

  // ...
}</code></pre>
<p>The need to manage local state with a reducer in a complex component is common enough that we’ve built the <code>useReducer</code> Hook right into React. You’ll find it together with other built-in Hooks in the <a href="/docs/hooks-reference.html">Hooks API reference</a>.</p>
</body></html>
